import Vue from 'vue'
import Vuex from 'vuex'

import actions from '@/store/actions'
import getters from '@/store/getters'
import mutations from '@/store/mutations'
import state from '@/store/state'

/* date*/
import date from '@/store/modules/date'
/* user - company*/
import user from '@/store/modules/user'
import company  from '@/store/modules/company'
/*Customre - invoices moveLine */
import customers from '@/store/modules/customers'
import invoices from '@/store/modules/invoices'
import moveLines from '@/store/modules/moveLines'
/* jounarl*/
import journals from '@/store/modules/journals'
/* currency */
import currency  from '@/store/modules/currency'

import payments  from '@/store/modules/payments'
/* BANK*/
import bank from '@/store/modules/bank'
import bankType  from '@/store/modules/bankType'

Vue.use(Vuex)

const store = new Vuex.Store({
    state,
    getters,
    mutations,
    actions,
    modules: {
        date,
        user,
        company,
        customers,
        invoices,
        moveLines,
        journals,
        currency,
        payments,
        bank,
        bankType
    },
    strict: true
})

export default store
