import { INIT_PAYMENTS_CURRENCIES, RESET_CURRENCY, INIT_CURRENCIES_AMOUNT, RESET_PAYMENTS } from '@/constants/actionTypes'
import { SET_CURRENCIES, SET_LOADING_CURRENCIES, SET_CURRENCIES_AMOUNT } from '@/constants/mutationTypes'


const initialState = {
    currency: [],
    loadingCurrency: false,
    currencyAmount: []
}

const state = {
    currency: initialState.currency,
    loadingCurrency: initialState.loadingCurrency,
    currencyAmount: initialState.currencyAmount
}

const getters = {
    /**
     * [currency]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    currency(state) {
        return state.currency
    },
    /**
     * [loadingCurrency]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    loadingCurrency(state) {
        return state.loadingCurrency
    },
    /**
     * [currencyAmount description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    currencyAmount (state) {
        return state.currencyAmount
    }
}

const mutations = {
    /**
     * [currency]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_CURRENCIES] (state, payload) {
        state.currency = payload
    },
    /**
     * [loadingCurrency]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_LOADING_CURRENCIES] (state, payload) {
        state.loadingCurrency = !!payload
    },
    /**
     * [actions description]
     * @type {Object}
     */
    [SET_CURRENCIES_AMOUNT] (state, payload) {
        let currency = payload.currency
        let currencyMove = payload.currencyMovePayments
        let amountCurrency = []

        currency.forEach(item => {
            let amount = 0
            currencyMove.forEach(currency =>{
                let currencyMoveLine = currency.currencyAmount.find(move => move.id === item.id)
                amount = amount + currencyMoveLine.amountCurencyResidual
            })
            amountCurrency.push({
                    id: item.id, 
                    symbolCurrency: item.symbol,
                    amount: amount,
                    symbol: ' ',
                    position: 'before',
                    thousandsSeparator: item.thousandsSeparator,
                    decimalSeparator: item.decimalSeparator,
                    decimalPlaces: item.decimalPlaces,
                    rateSilent: item.rateSilent
            })
        })
        state.currencyAmount = amountCurrency
    }
}

const actions = {
    /**
     * [INIT_CURRENCIES]
     * @param {*} param0
     * @param {*} payload
     */
    [INIT_PAYMENTS_CURRENCIES] ({commit}, payload) {
        commit(SET_CURRENCIES, payload)
        commit(SET_LOADING_CURRENCIES, payload)
    },
    /**
     * [currencyInvoiceRate description]
     * @type {[type]}
     */
    [RESET_CURRENCY] ({ commit }) {
        commit(SET_CURRENCIES, [] )
    },
    /**
     * [currencyInvoiceRate description]
     * @type {[type]}
     */
    [INIT_CURRENCIES_AMOUNT] ({ commit, getters, dispatch}) {
        commit(SET_CURRENCIES_AMOUNT, {
            currencyMovePayments: getters.movesPayments,
            currency: getters.currency
        })
        dispatch(RESET_PAYMENTS)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
