import { INIT_PAYMENTS_DATE, RESET_DATE } from '@/constants/actionTypes'
import { SET_DATE, SET_LOADING_DATE } from '@/constants/mutationTypes'

const initialState = {
    date: null,
    loadingDate: false
}

const state = {
    date: initialState.date,
    loadingDate: !initialState.loadingDate
}

const getters = {
    /**
     * [date description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    date(state) {
        return state.date
    },
    /**
     * [loadingDate description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    loadingDate(state) {
        return state.loadingDate
    }
}

const mutations = {
    /**
     * [date description]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_DATE] (state, payload) {
        state.date = payload
    },
    /**
     * [loadingDate description]
     * @param  {[type]} state [description]
     * @param  {[type]} payload [description]
     */
    [SET_LOADING_DATE](state, payload) {
        state.loadingDate = !!payload
    }
}

const actions = {
    /**
     *
     * @param {*} param0
     * @param {*} payload
     */
    [INIT_PAYMENTS_DATE] ({ commit}, payload) {
        commit(SET_DATE, payload)
        commit(SET_LOADING_DATE, payload)
    },
    /**
     *
     * @param {*} param0
     * @param {*} payload
     */
    [RESET_DATE] ({ commit }) {
        commit(SET_DATE, [])
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
